<?php
# 2005 apr 30

#drop table if exists loginpermission;
#create table loginpermission
#(
#  id int primary key not null auto_increment,
#  lastinsert datetime default "0000-00-00 00:00:00",
#  lastupdate datetime default "0000-00-00 00:00:00",
#  username varchar(64) not null,
#  permission varchar(64) not null,
#  unique key userpermkey (username, permission)
#);

include_once("usermenu.inc");

class useradmin extends usermenu
{
  function useradmin
  (
  )
  {
    usermenu::usermenu();

    $this->label["searchusername"] = "Username";
    $this->label["search"] = "Search";
    $this->label["new"] = "New";
    $this->label["modify"] = "Modify";
    $this->label["remove"] = "Remove";
    $this->label["removalconfirmation"] = "Confirm removal of the following user?";
    $this->label["save"] = "Save";
    $this->label["responsemessage"] = "";
    $this->label["removalerror"] = "Cannot remove user.";
    $this->label["passworderror"] = "Password error.";
    $this->label["processcompleted"] = "Process completed.";
    $this->label["usernameerror"] = "Username error.";
    $this->label["permission"] = "Permission";

    return;
  }

  function getstate
  (
  )
  {
    usermenu::getstate();

    return;
  }

  function gethiddentags
  (
  )
  {
    $str = "";
    $str .= sprintf("%s", usermenu::gethiddentags());
    $hiddenarray =
      array
      (
        "objfuncconfirm" => sprintf("%s", ""),
      );
    reset($hiddenarray);
    while(list($hiddenkey,$hiddenvalue) = each($hiddenarray))
    {
      $str .= <<<_STR_
<input type="hidden" name="${hiddenkey}" value="${hiddenvalue}">
_STR_;
    }
    return $str;
  }

  function getpaneltags
  (
  )
  {
    $searchtags = sprintf("%s", $this->getsearchtags());
    $navigationtags = sprintf("%s", $this->getnavigationtags());
    $controltags = sprintf("%s", $this->getcontroltags());
    $labelobj = sprintf("%s", $this->label["".get_class($this)]);
    $str = "";
    $str .= <<<_STR_
<table width="800" cellspacing="0" cellpadding="0" border="1">
<td valign="top" colspan="2">
<center>
<b>[ ${labelobj} ]</b>
<br><br>
<!hr width="100%" noshade>
${searchtags}
</center>
</td>
</tr>
<tr>
<td valign="top" width="1%">
${navigationtags}
&nbsp;
</td>
<td valign="top">
${controltags}
&nbsp;
</td>
</tr>
</table>
_STR_;
    return $str;
  }

  function getobjfunctags
  (
  )
  {
    $obj = get_class($this);
    $menuarray =
      array
      (
        "new" => "",
        "modify" => "",
        "remove" => "",
      );
    $str = "";
    $str .= <<<_STR_
<table width="100%" cellspacing="0" cellpadding="0" bgcolor="#ffffff">
<tr>
<td valign="top">
<div align="right">
_STR_;
    reset($menuarray);
    while(list($menukey,$menuvalue) = each($menuarray))
    {
      $label=$this->label["${menukey}"];
      $str .= <<<_STR_
&nbsp;<a href="javascript:setobjfunc('${obj}','${menukey}');">${label}</a> |
_STR_;
    }
    $str .= <<<_STR_
</div>
</td>
</tr>
</table>
_STR_;
    return $str;
  }

  function getsearchtags
  (
  )
  {
    $obj = get_class($this);
    $menuarray =
      array
      (
        "searchusername" => sprintf("%s", $this->vars["searchusername"]),
      );
    $str = "";
    $str .= <<<_STR_
<table cellspacing="0" cellpadding="0" bgcolor="#ffffff">
<tr>
_STR_;
    reset($menuarray);
    while(list($menukey,$menuvalue) = each($menuarray))
    {
      $label=$this->label["${menukey}"];
      $str .= <<<_STR_
<td valign="top"><b>${label} :&nbsp;</b></td>
<td valign="top"><input type="text" name="${menukey}" value="${menuvalue}"></td>
_STR_;
    }
    $labelsearch = $this->label["search"];
    $str .= <<<_STR_
<td valign="top">&nbsp;</td>
<td valign="top"><input class="globalbutton" type="button" onclick="javascript:setobjfunc('${obj}','');" value="${labelsearch}"></td>
</tr>
</table>
_STR_;
    return $str;
  }

  function getnavigationtags
  (
  )
  {
    $obj = get_class($this);

    $condition = "";
    if ($this->vars["searchusername"] != "")
    {
      $condition = sprintf(" where username like \"%s%%\" ",
        $this->vars["searchusername"]);
    }
    $sql = sprintf("select * from loginaccount %s order by username;",
      $condition);
    $db = new dbmysql();
    $db->setquery($sql);
    reset($db->result);
    while(list($dbkey,$dbvalue) = each($db->result))
    {
      $dbarray["$dbkey"] = $dbvalue["loginaccount.username"];
    }
    $dbarray[""] = "";

#    asort($dbarray);
    natcasesort($dbarray);

    reset($dbarray);
    while(list($dbkey,$dbvalue) = each($dbarray))
    {
      $selected = "";
      if ($dbvalue == $this->vars["objid"])
      {
        $selected = "selected";
      }
      $optiontags .= sprintf("<option value=\"%s\" %s>%s</option>\n",
        $dbvalue,
        $selected,
        $dbvalue);
    }

    $str = "";
    $str .= <<<_STR_
<script>
var objlistarray=new Array();
function setobjid
(
  objid
)
{
  setobjfunc('${obj}', '');
  return;
}
</script>
<div id="dividobjlist">
<select name="objid" onchange="javascript:setobjid(this.value);">
${optiontags}
</select>
</div>
_STR_;
    return $str;
  }

  function getcontroltags
  (
  )
  {
    $obj = get_class($this);
    $objid = $this->vars["objid"];
    $responsemessage = $this->responsemessage;
    $str = "";
    $str .= <<<_STR_
<script>
var objid='';
</script>
<table width="100%" bgcolor="#99ccff">
<tr>
<td valign="top">
<div align="right">
_STR_;
    $menuarray =
      array
      (
        "new" => sprintf("%s", $this->label["new"]),
        "modify" => sprintf("%s", $this->label["modify"]),
        "remove" => sprintf("%s", $this->label["remove"]),
      );
    $labelobjfunc = sprintf("[ %s ]", $this->label["modify"]);
    reset($menuarray);
    while(list($menukey,$menuvalue) = each($menuarray))
    {
      $label=$this->label["${menukey}"];
      if ($menukey == $this->vars["objfunc"])
      {
        $labelobjfunc = sprintf("[ %s ]", $menuvalue);
      }
      $str .= <<<_STR_
[ <a class="globallink" href="javascript:setobjfunc('${obj}','${menukey}');">${menuvalue}</a> ]&nbsp;
_STR_;
    }
    $str .= <<<_STR_
</div>
</td>
</tr>
</table>
<table width="100%" cellpadding="0" cellspacing="0" bgcolor="#ffffff"><tr><td valign="top"><center>&nbsp;${responsemessage}</center></td></tr></table>
<table width="100%" cellpadding="0" cellspacing="0" bgcolor="#ffffff"><tr><td valign="top"><b>&nbsp;${labelobjfunc}</b></td></tr></table>
_STR_;
    $objfunc = $this->vars["objfunc"];
    if (($this->vars["objfunc"] == "") &&
        ($this->vars["objid"] != ""))
    {
      $objfunc = "modify";
    }
    if ($objfunc == "new")
    {
      $str .= $this->getobjfuncnewtags();
    }
    if ($objfunc == "modify")
    {
      $str .= $this->getobjfuncmodifytags();
    }
    if ($objfunc == "remove")
    {
      $str .= $this->getobjfuncremovetags();
    }
    return $str;
  }

  function getobjfuncnewtags
  (
  )
  {
    $obj = $this->vars["obj"];
    $objfunc = $this->vars["objfunc"];
    $labelusername = $this->label["username"];
    $labelsave = $this->label["save"];
    $labelusernameerror = $this->label["usernameerror"];
    $str = <<<_STR_
<script>
function setnew
(
)
{
  if (document.forms[0].username.value == '')
  {
    alert('${labelusernameerror}');
    return;
  }
  document.forms[0].objfuncconfirm.value='true';
  setobjfunc('${obj}','${objfunc}');
  return;
}
</script>
<table>
<tr>
<td valign="top"><b>${labelusername} :&nbsp;</b></td>
<td valign="top"><input type="text" name="username" maxlength="16" size="16"></td>
</tr>
<tr>
<td valign="top">&nbsp;</td>
<td valign="top"><input type="button" class="globalbutton" onclick="javascript:setnew();" value=" ${labelsave} "></td>
</tr>
</table>
_STR_;

    return $str;
  }

  function getobjfuncmodifytags
  (
  )
  {
    $obj = $this->vars["obj"];
    $objid = $this->vars["objid"];
    $objfunc = "modify";
    $labelsave = $this->label["save"];
    $labelpassworderror = $this->label["passworderror"];
    $labelpermission = $this->label["permission"];
    $str .= <<<_STR_
<table>
_STR_;
    $fieldarray =
      array
      (
        "password" => sprintf("%s", $this->label["password"]),
      );
    reset($fieldarray);
    while(list($fieldkey,$fieldvalue) = each($fieldarray))
    {
      $label=$this->label["${fieldkey}"];
      $fieldtype = "text";
      $inputtag = sprintf("<input type=\"%s\" name=\"%s\" value=\"\">\n",
        $fieldtype,
        $fieldkey);
      if ($fieldkey == "password")
      {
        $fieldtype = "password";
        $inputtag = sprintf("<input type=\"%s\" maxlength=\"16\" size=\"16\" name=\"%s\" value=\"\">\n",
          $fieldtype,
          $fieldkey);
      }
      $str .= <<<_STR_
<tr>
<td valign="top"><b>${fieldvalue} :&nbsp;</b></td>
<td valign="top">${inputtag}</td>
</tr>
_STR_;
    }

    if ($this->vars["objid"] != $this->masteradmin)
    {
      $str .= <<<_STR_
<tr>
<td valign="top"><b>${labelpermission} :&nbsp;</b></td>
<td valign="top">
_STR_;
      $str .= sprintf("<select name=\"permission[]\" size=\"3\" multiple>\n");
      $fieldarray =
        array
        (
          "userhome" => sprintf("%s", ""),
          "useradmin" => sprintf("%s", ""),
          "logout" => sprintf("%s", ""),
        );
      $sql = sprintf("select permission from loginpermission where username=\"%s\";",
        mysql_escape_string($this->vars["objid"]));
      $db = new dbmysql();
      $db->setquery($sql);
      unset($dbarray);
      if(sizeof($db->result) > 0)
      {
        reset($db->result);
        while(list($dbkey,$dbvalue) = each($db->result))
        {
          $dbarray[$dbkey]=sprintf("%s", $dbvalue["loginpermission.permission"]);
        }
      }
      reset($fieldarray);
      while(list($fieldkey,$fieldvalue) = each($fieldarray))
      {
        $selected = "";
        if (sizeof($dbarray) > 0)
        {
          if (in_array($fieldkey, $dbarray) == true)
          {
            $selected = "selected";
          }
        }
        $fieldarray["$fieldkey"] = $fieldvalue = sprintf("%s", $this->label["$fieldkey"]);
        $str .= sprintf("<option value=\"%s\" %s>%s</option>\n",
          $fieldkey,
          $selected,
          $fieldvalue);
      }
      $str .= sprintf("</select>\n");
    }

    $str .= <<<_STR_
</td>
</tr>
<tr>
<td valign="top">&nbsp;</td>
<td valign="top"><input type="button" class="globalbutton" onclick="javascript:setmodify();" value=" ${labelsave} "></td>
</tr>
_STR_;

    $str .= <<<_STR_
</table>
<script>
function setmodify
(
)
{
  if (document.forms[0].password.value == '')
  {
    alert('${labelpassworderror}');
    return;
  }
  document.forms[0].objfuncconfirm.value = 'true';
  setobjfunc('${obj}','${objfunc}');
  return;
}
</script>
<input type="hidden" name="username" value="${objid}">
_STR_;
    return $str;
  }

  function getobjfuncremovetags
  (
  )
  {
    ${obj} = $this->vars["obj"];
    ${objid} = $this->vars["objid"];
    ${objfunc} = $this->vars["objfunc"];
    ${removalerror}=sprintf("%s", $this->label["removalerror"]);
    ${removalconfirmation}=sprintf("%s", $this->label["removalconfirmation"]);
    $labelremove = sprintf("%s", $this->label["remove"]);
    if ($objid == $this->masteradmin)
    {
      $str .= <<<_STR_
${removalerror}
_STR_;
    }
    if ($objid != $this->masteradmin)
    {
      if (($objid != "") &&
          ($this->vars["objfuncconfirm"] != "true"))
      {
        $str .= <<<_STR_
<center>
${removalconfirmation}
<br><br>
<b>${objid}</b>
<br><br>
<input type="hidden" name="username" value="${objid}">
<input type="button" class="globalbutton" onclick="javascript:document.forms[0].objfuncconfirm.value='true';setobjfunc('${obj}','${objfunc}');" value=" ${labelremove} ">
</center>
_STR_;
      }
    }
    return $str;
  }

  function settransaction
  (
  )
  {
    usermenu::settransaction();

    if ($this->vars["username"] == "")
    {
      return;
    }
    if ($this->vars["objfuncconfirm"] != "true")
    {
      return;
    }
    $datetimenow = date("Y-m-d H:i:s");
    $this->responsemessage = $this->label["processcompleted"];

    if ($this->vars["objfunc"] == "new")
    {
      $sql = sprintf("select max(id) from loginaccount;");
      $db=new dbmysql();
      $db->setquery($sql);

      $maxid = sprintf("%d", $db->result[0][".max(id)"]) + 1;
      $sql = sprintf("insert into loginaccount values(\"%s\", \"%s\", \"%s\", \"%s\", password(\"%s\"));",
        mysql_escape_string($maxid),
        mysql_escape_string($datetimenow),
        mysql_escape_string($datetimenow),
        mysql_escape_string($this->vars["username"]),
        "");
      $db=new dbmysql();
      $db->setquery($sql);
      $this->vars["objid"] = $this->vars["username"];
      $this->vars["objfunc"] = "modify";
      return;
    }
    if ($this->vars["objfunc"] == "modify")
    {
# User password
      unset($recordarray);
      $recordarray =
        array
        (
          "lastupdate" => sprintf("lastupdate=\"%s\"", $datetimenow),
          "password" => sprintf("password=\"%s\"", $this->vars["password"]),
        );
      $recordarray["password"]=sprintf("password=password(\"%s\")",
        $this->vars["password"]);
      $sql = sprintf("update loginaccount set %s where username=\"%s\";",
        implode(",", $recordarray),
        $this->vars["username"]);
      $db=new dbmysql();
      $db->setquery($sql);
# User permission
      $sql = sprintf("delete from loginpermission where username=\"%s\";",
        mysql_escape_string($this->vars["username"]));
      $db=new dbmysql();
      $db->setquery($sql);
#      $this->vars["permission"][]="logout";
#      $this->vars["permission"][]="usermenu";
#      array_unique($this->vars["permission"]);
      if (sizeof($this->vars["permission"]) <= 0)
      {
        return;
      }
      reset($this->vars["permission"]);
      while(list($permkey,$permvalue) = each($this->vars["permission"]))
      {
        $sql = sprintf("select max(id) from loginpermission;");
        $db=new dbmysql();
        $db->setquery($sql);
        $maxid = sprintf("%d", $db->result[0][".max(id)"]) + 1;
        $sql = sprintf("insert into loginpermission values(\"%s\", \"%s\", \"%s\", \"%s\", \"%s\");",
          mysql_escape_string($maxid),
          mysql_escape_string($datetimenow),
          mysql_escape_string($datetimenow),
          mysql_escape_string($this->vars["username"]),
          mysql_escape_string($permvalue));
        $db=new dbmysql();
        $db->setquery($sql);
      }
      return;
    }
    if ($this->vars["objfunc"] == "remove")
    {
      if ($this->vars["username"] == $this->masteradmin)
      {
        $this->responsemessage = $this->label["removalerror"];
        return;
      }
      $sql = sprintf("delete from loginpermission where username=\"%s\";",
        $this->vars["username"]);
      $db=new dbmysql();
      $db->setquery($sql);
      $sql = sprintf("delete from userfile where username=\"%s\";",
        mysql_escape_string($this->vars["username"]));
      $db=new dbmysql();
      $db->setquery($sql);
      $sql = sprintf("delete from loginaccount where username=\"%s\";",
        mysql_escape_string($this->vars["username"]));
      $db=new dbmysql();
      $db->setquery($sql);
#
      $sql = sprintf("delete from useraddressbook where username=\"%s\";",
        mysql_escape_string($this->vars["username"]));
      $db=new dbmysql();
      $db->setquery($sql);
      return;
    }

    return;
  }
}
?>
